"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.clone_redis_connection = exports.prepare_redis_script = void 0;
const ioredis_1 = __importDefault(require("ioredis"));
function prepare_redis_script(redis, script) {
    return __awaiter(this, void 0, void 0, function* () {
        const hash = yield redis.call('SCRIPT', ['LOAD', script]);
        return (args, keys) => __awaiter(this, void 0, void 0, function* () {
            return yield redis.call('EVALSHA', [hash, keys.length, ...keys, ...args]);
        });
    });
}
exports.prepare_redis_script = prepare_redis_script;
;
function clone_redis_connection(redis) {
    return __awaiter(this, void 0, void 0, function* () {
        return yield new Promise((resolve, reject) => {
            const copy = new ioredis_1.default(Object.assign(Object.assign({}, redis.options), { lazyConnect: false }));
            copy.once('connect', () => { resolve(copy); });
            copy.once('error', (err) => { reject(err); });
        });
    });
}
exports.clone_redis_connection = clone_redis_connection;
//# sourceMappingURL=redis-utils.js.map